/***************************************************************************/
/* 		This code is part of Nscache - viewer of Netscape(tm)	   */
/*		browsers disk cache					   */
/*		Copyright (c) 1999,2000 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		modified 2005 ... 2011 by Harald Foerster		   */
/*		(harald_foerster@users.sourceforge.net)			   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef _moz_h_
#define _moz_h_

#include <sys/types.h>

#include "nscache.h"

/*
#include <glib.h>
*/

#ifndef MOZ_MIN_VERSION
#define MOZ_MIN_VERSION		0x00010003
#endif

#ifdef MOZ_ENABLE_MAX_VERSION

/* Version 1.19 (since SeaMonkey 2.1 - maybe earlier) */
#ifndef MOZ_MAX_VERSION
#define MOZ_MAX_VERSION		0x00010013
#endif

#endif /* MOZ_ENABLE_MAX_VERSION_TEST */

typedef struct
{
	nscache_record_t	record;
	guint32			recordid;

} moz_record_t;

extern NSC_BROWSER moz_browser;

extern int   moz_file_access(const nscache_record_t *nsc_rec);
extern int   moz_blk_access(const nscache_record_t *nsc_rec);
extern int   moz_blk_read_open(void);
extern void  moz_blk_read_close(void);

#ifndef CACHE_READONLY
extern int    moz_blk_delete_open(void);
extern char  *moz_blk_delete_close(void);
#endif

#endif /* _moz_h_ */
