/***************************************************************************/
/* 		This code is part of Nscache - viewer of Netscape(tm)	   */
/*		browsers disk cache					   */
/*		Copyright (c) 1999,2000 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		modified 2005 ... 2012 by Harald Foerster		   */
/*		(harald_foerster@users.sourceforge.net)			   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef _nls_H_
#define _nls_H_

extern const char *nscache_package_str;

#define CATALOG_NAME	nscache_package_str

#ifdef HAVE_GETTEXT

#include <locale.h>
#include <libintl.h>

#define NLS_TEXTDOMAIN(plocale, pnlsdir)	\
{						\
	setlocale(LC_CTYPE, plocale);		\
	bindtextdomain(CATALOG_NAME,		\
	  pnlsdir == NULL ? NLS_DIR : pnlsdir);	\
	textdomain(CATALOG_NAME);		\
}

#ifdef LC_MESSAGES

#define NLS_INIT_LOCALE(nlsdir) \
	  NLS_TEXTDOMAIN(setlocale(LC_MESSAGES, ""), nlsdir)

#else

#define NLS_INIT_LOCALE(nlsdir)	NLS_TEXTDOMAIN("", nlsdir)

#endif /* LC_MESSAGES */

#else /* ! HAVE_GETTEXT */

#ifdef HAVE_LOCALE
#include <locale.h>
#define NLS_INIT_LOCALE(nlsdir)	setlocale(LC_CTYPE, "")
#else
#define NLS_INIT_LOCALE(nlsdir)
#endif

#define gettext(str)		((char *) str)

#endif /* HAVE_GETTEXT */

#define gettext_nop(str)	(str)

#endif /* _nls_H_ */
