/***************************************************************************/
/* 		This code is part of Nscache - viewer of Netscape(tm)	   */
/*		browsers disk cache					   */
/*		Copyright (c) 1999,2000 Ondrejicka Stefan		   */
/*		(ondrej@idata.sk)					   */
/*		created 2009 by Harald Foerster				   */
/*		(harald_foerster@users.sourceforge.net)			   */
/*		Distributed under GPL 2 or later			   */
/***************************************************************************/

#ifndef XSEARCH_H
#define XSEARCH_H

#include "unicode-tools.h"

/*
#include <glib.h>
#include "charconv.h"
#include "nls.h"
*/

#ifdef UNICODE_CHAR_T

#define HAVE_XSEARCH	1

typedef struct
{
	gsize		pos;
	gsize		plen;
	gsize		blen;
	guchar		bstr[1];

} entity_conv_t;

typedef struct
{
	gsize		plen;
	gchar		*str_lo;
	gchar		*str_up;
	entity_conv_t	**entities_doc;
	entity_conv_t	**entities_pat_chr;
	entity_conv_t	**entities_pat_str;
	const gchar	*charset;

} xsearch_t;

void  xsearch_get_entities_doc(xsearch_t *xptr);
void  xsearch_get_entities_pat(xsearch_t *xptr);
void  xsearch_free_entities(xsearch_t *xptr);
gchar *xsearch_mem_find_str(const xsearch_t *xptr, const gchar *mem, gint mlen, gint *end_offs);

#endif /* UNICODE_CHAR_T */

#endif /* XSEARCH_H */
